# baseitem.py
import os
import grok
from waeup.viewlets import MainArea, Edit
from waeup.interfaces import IBaseItem
from zope.component import getMultiAdapter

class BaseItem(grok.Model):
    """
    Base item
    """
    grok.implements(IBaseItem)
    
class Content(grok.Viewlet):
    grok.viewletmanager(MainArea)
    grok.context(IBaseItem)


#class Edit(grok.EditForm):
#    
#    def update(self):
#        self.form_fields = grok.AutoFields(self.context.__class__)
#        grok.EditForm.update(self)


class AddForm(grok.AddForm):
    #grok.template('edit_form')
    template = grok.PageTemplate(filename=os.path.join('baseitem_templates', 'edit_form.pt'))

    def update(self):
        self.form_fields = grok.AutoFields(self.context.childClass)
        grok.AddForm.update(self)

    @grok.action('Add item')
    def add(self, **data):
        obj = self.context.childClass(**data)
        name = data['name'].lower().replace(' ', '_')
        self.context[name] = obj

class Add(grok.Viewlet):
    grok.viewletmanager(MainArea)
    #grok.template('edit_form')
    grok.context(IBaseItem)
    grok.view(Edit)

    def update(self):
        self.form = getMultiAdapter((self.context, self.request),
                                    name='addform')
        self.form.update_form()

    def render(self):
        return self.form.render()
